#include <ESP8266WiFi.h>
#include <Servo.h>

const char*ssid="Evolukid";
const char*password="evolukid";

#define SERVO 2

WiFiServer server(80);
Servo monServomoteur;

bool ouvert;

void setup() {
  
  monServomoteur.attach(SERVO);
  pinMode(SERVO,INPUT);

  Serial.begin(9600);
  Serial.print("Connexion à ");
  Serial.println(ssid);

  WiFi.begin(ssid,password);

  while(WiFi.status() != WL_CONNECTED){
    delay(500);
    Serial.print(".");
  }

  Serial.println("WIFI OK");
  server.begin();
  Serial.println("SERVER OK");

  Serial.println(WiFi.localIP());
}

void loop() {

  WiFiClient client = server.available();
  if(!client){
    return;
  }

  while(!client.available()){
    delay(10);
  }

  String request = client.readStringUntil('\r');
  client.flush();
  
  if(request.indexOf("ACTION=CALIBRATE")!=-1){
    calibrate();
    }
  else if(request.indexOf("ACTION=LOCK")!=-1){
    if(ouvert){
      lock();
      }
    }
  else if (request.indexOf("ACTION=UNLOCK")!=-1){
    if(!ouvert){
      unlock();
      }
    } 
}

void unlock(){
  pinMode(SERVO,OUTPUT);
  monServomoteur.write(180);
  delay(9000);
  monServomoteur.write(90);
  pinMode(SERVO,INPUT);
  ouvert = true;
}

void lock(){
  pinMode(SERVO,OUTPUT);
  monServomoteur.write(0);
  delay(9000);
  monServomoteur.write(90);
  pinMode(SERVO,INPUT);
  ouvert = false;
}

void calibrate(){
  pinMode(SERVO,OUTPUT);
  monServomoteur.write(180);
  delay(13000);
  monServomoteur.write(90);
  pinMode(SERVO,INPUT);
  ouvert = true;
}
